Subject: Re: git submodule ignores --git-dir

From: Jens Lehmann <[email-masked]>
Date: Fri, 11 Sep 2015 17:15:52 +0200

Am 10.09.2015 um 22:06 schrieb Filip Gospodinov:
> Hi!
>
> I use the `--git-dir` flag in some scripts such that I don't need to `cd` back
> and forth. Recently, I've discovered that `--git-dir` does not seem to work
> correctly for `git submodule`. Here is a short snippet to reproduce that behavior:
>
> mkdir repo1 subm
> (cd subm; git init; git commit -m 1 --allow-empty)
> (cd repo1; git init; git submodule add ../subm subm; git commit -m "add subm")
> git clone repo1 repo2
> git --git-dir=$PWD/repo2/.git submodule update --init
>
>
> which errors with the following output:
>
> No submodule mapping found in .gitmodules for path 'subm'
>
> But this works:
> cd repo2; git --git-dir=$PWD/.git submodule update --init

Thanks for your report containing a nice recipe to reproduce your issue!

> I know that for this particular use case I can just use `git clone --recursive`
> and that other use cases can be worked around by using `cd`. Still, I wonder if
> the behavior I discovered is a bug or if it's expected.

I don't think this is a bug. The git submodule command needs a work tree
to read the .gitmodules file from, that's while it fails when using
--git-dir from outside the work tree. But I admit that the error message
"No submodule mapping found in .gitmodules for path ..." could be improved
to clearly state that the .gitmodules file wasn't found.

Unfortunately trying to show git the right work tree:

$ git --git-dir=$PWD/repo2/.git --work-tree=$PWD/repo2 submodule update --init

Didn't work as I expected it to either:

fatal: /home/Sledge/libexec/git-core/git-submodule cannot be used without a working tree.

So you'll have to cd into the repo for now.